﻿@using System.Text.RegularExpressions
@using LoyaltyPointEngine.Model.Object.ConvertPoint;
@model IEnumerable<ConvertPointReportModel>
@{
    string orderColumn = ViewBag.OrderColumn,
        orderDirection = ViewBag.OrderDirection,
        startDate = ViewBag.StartDate,
        endDate = ViewBag.EndDate;

    int currentPage = ViewBag.CurrentPage,
        totalPage = ViewBag.TotalPage,
        pageSize = ViewBag.PageSize,
        totalRow = ViewBag.TotalRow;
}

<div id="grid-wrapper" class="widget-content">
    <table class="table table-striped grid-table">
        <thead>
            <tr>
                @RenderTableHead(startDate, endDate, orderDirection, currentPage)
                <th class="grid-header cell-center" title=""><div class="grid-header-title"><span></span></div></th>
                <th class="grid-header cell-center" title=""><div class="grid-header-title"><span></span></div></th>
            </tr>
        </thead>
        <tbody>
            @foreach(ConvertPointReportModel receipt in Model)
            {
                @RenderTableRow(receipt, startDate, endDate, orderDirection, 1)
            }
        </tbody>
    </table>
    @if (totalPage > 1)
    {
        int startPage = currentPage - pageSize > 1 ? currentPage - pageSize : 1,
            endPage = currentPage + pageSize < totalPage ? currentPage + pageSize : totalPage;

        <div class="grid-footer">

            <div class="grid-pager">
                <ul class="pagination">
                    <li>
                        <a data-url="@GenerateUrl(startDate, endDate, orderColumn, orderDirection, currentPage <= 1 ? currentPage : currentPage - 1)" class="grid-prev-page" title="Previous Page" style="">
                            <span class="glyphicon glyphicon-step-backward"></span>
                        </a>
                    </li>
                    @for (var _page = startPage; _page <= endPage; _page++)
                    {
                        <li class="@(currentPage == _page ? "active": "")">
                            <a data-url="@GenerateUrl(startDate, endDate, orderColumn, orderDirection, _page)" class="grid-page-link">
                                @_page
                            </a>
                        </li>
                    }
                    @if (totalPage >= 7)
                    {
                        <li>
                            <a class="grid-page-link">
                                Total Page @totalPage
                            </a>
                        </li>
                    }
                    <li>
                        <a data-url="@GenerateUrl(startDate, endDate, orderColumn, orderDirection, currentPage >= endPage ? endPage : currentPage + 1)" title="Next Page" class="grid-next-page">
                            <span class="glyphicon glyphicon-step-forward"></span>
                        </a>
                    </li>
                </ul>
            </div>
            <div>
                Total Row : @totalRow
            </div>
        </div>
    }
</div>

@helper RenderTableHead(string startDate, string endDate, string orderDirection, int page)
{
    Type type = typeof(ConvertPointReportModel);
    foreach (var prop in type.GetProperties())
    {
        <th class="grid-header" title="MemberPhone">
            <div class="grid-header-title">
                <a data-url="@GenerateUrl(startDate, endDate, prop.Name, orderDirection, page, true)">@GetName(prop.Name)</a>
            </div>
        </th>
    }
}

@helper RenderTableRow(ConvertPointReportModel data, string startDate, string endDate, string orderDirection, int page)
{
    Type type = typeof(ConvertPointReportModel);
    <tr class="grid-row">
        @foreach (var prop in type.GetProperties())
        {
            if (prop.GetValue(data) != null)
            {
                <td class="grid-cell" data-name="@prop.Name">@(prop.GetValue(data))</td>
            }
        }
    </tr>
}

@functions {
    public string GenerateUrl(string startDate, string endDate, string orderColumn, string orderDirection, int page, bool isSorting = false)
    {
        if (isSorting)
        {
            orderDirection = orderDirection.ToUpper() == "DESC" ? "ASC" : "DESC";
        }
        return Url.Action(MVC.ConvertPointReporting.GridGetAllPager(startDate, endDate, orderColumn, orderDirection, page));
    }

    public string GetName(string propName)
    {
        string ret = "";
        if (!string.IsNullOrEmpty(propName))
        {
            ret = Regex.Replace(propName, @"(\p{Lu})", " $1");
        }
        return ret;
    }
}